# coding: utf-8

"""
    Loci Notes Server

     The [Loci Notes](https://loci-notes.gitlab.io/) server API.  The Loci Notes server is a FastAPI server that provides a RESTful API for interacting with the Loci Notes system. The server is designed to be used by the Loci Notes web UI, VS Code extension, Loci Notes CLI, and any other clients that may be developed in the future.

    The version of the OpenAPI document: 0.20240713.191920
    Contact: thetwitchy@thetwitchy.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from loci_client.models.artifact_descriptor import ArtifactDescriptor
from loci_client.models.artifact_id import ArtifactId
from loci_client.models.artifact_in_priority import ArtifactInPriority
from loci_client.models.artifact_in_status import ArtifactInStatus
from loci_client.models.artifact_in_type import ArtifactInType
from loci_client.models.artifact_note_type_enum import ArtifactNoteTypeEnum
from loci_client.models.submission_tool import SubmissionTool
from typing import Optional, Set
from typing_extensions import Self

class ArtifactNoteIn(BaseModel):
    """
    ArtifactNoteIn
    """ # noqa: E501
    artifact_id: Optional[ArtifactId] = None
    artifact_descriptor: Optional[ArtifactDescriptor] = None
    artifact_type: Optional[ArtifactInType] = None
    artifact_priority: Optional[ArtifactInPriority] = None
    artifact_status: Optional[ArtifactInStatus] = None
    submission_tool: Optional[SubmissionTool] = None
    type: ArtifactNoteTypeEnum
    contents: StrictStr
    __properties: ClassVar[List[str]] = ["artifact_id", "artifact_descriptor", "artifact_type", "artifact_priority", "artifact_status", "submission_tool", "type", "contents"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ArtifactNoteIn from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of artifact_id
        if self.artifact_id:
            _dict['artifact_id'] = self.artifact_id.to_dict()
        # override the default output from pydantic by calling `to_dict()` of artifact_descriptor
        if self.artifact_descriptor:
            _dict['artifact_descriptor'] = self.artifact_descriptor.to_dict()
        # override the default output from pydantic by calling `to_dict()` of artifact_type
        if self.artifact_type:
            _dict['artifact_type'] = self.artifact_type.to_dict()
        # override the default output from pydantic by calling `to_dict()` of artifact_priority
        if self.artifact_priority:
            _dict['artifact_priority'] = self.artifact_priority.to_dict()
        # override the default output from pydantic by calling `to_dict()` of artifact_status
        if self.artifact_status:
            _dict['artifact_status'] = self.artifact_status.to_dict()
        # override the default output from pydantic by calling `to_dict()` of submission_tool
        if self.submission_tool:
            _dict['submission_tool'] = self.submission_tool.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ArtifactNoteIn from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "artifact_id": ArtifactId.from_dict(obj["artifact_id"]) if obj.get("artifact_id") is not None else None,
            "artifact_descriptor": ArtifactDescriptor.from_dict(obj["artifact_descriptor"]) if obj.get("artifact_descriptor") is not None else None,
            "artifact_type": ArtifactInType.from_dict(obj["artifact_type"]) if obj.get("artifact_type") is not None else None,
            "artifact_priority": ArtifactInPriority.from_dict(obj["artifact_priority"]) if obj.get("artifact_priority") is not None else None,
            "artifact_status": ArtifactInStatus.from_dict(obj["artifact_status"]) if obj.get("artifact_status") is not None else None,
            "submission_tool": SubmissionTool.from_dict(obj["submission_tool"]) if obj.get("submission_tool") is not None else None,
            "type": obj.get("type"),
            "contents": obj.get("contents")
        })
        return _obj


